#property copyright "Viseu"
#property link      "http://agoagu.blog35.fc2.com/"

extern int      magic               = 2008030801;
extern int      trade_open_time_h   = 19;    //̎Ԃ1ԃg[h\`FbN
extern int      trade_open_time_m   = 45;    //g[hJnԂx点镪
//extern int      trade_open_period_h   = 1;


extern double   fixed_lot_size      = 0.1;
extern double   tp1                  = 10;
//double   tp1                  = 10;
extern double   tp2                  = 9;
extern double   sl                  = 60;
//extern double   sl2                  = 60;


extern double   slippage            = 5;
extern double      split               =5;

#define DEF_MA_TYP              5
#define DEF_MA_NUM              4
double Buf_MA[ DEF_MA_TYP ][ DEF_MA_NUM ];
extern int    MA_prm_1     = 8;
extern int    MA_prm_2     = 17;
extern int    MA_prm_3     = 20;
extern int    MA_prm_4     = 29;
extern int    MA_prm_5     = 37;
extern int    MA_shift     = 1;
extern int    RSI_period   = 28;
extern double RSI_upper    = 55;
extern double RSI_lower    = 45;

int     POS_n_BUY;
int     POS_n_SELL;
int     POS_n_total;


#define SIG_Buy                 0               // VKBUY
#define SIG_Sell                1               // VKSELL
#define SIG_MAX                 2
bool    TradeSign[SIG_MAX];

////////////////////////////////////////////////////////////////////////
int init()
{
    return(0);
}

////////////////////////////////////////////////////////////////////////
void count_position()
{
    POS_n_BUY  = 0;
    POS_n_SELL = 0;

    for( int i = 0 ; i < OrdersTotal() ; i++ ){
        if( OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) == false ){
            break;
        }
        if( OrderMagicNumber() != magic ){
            continue;
        }
        if( OrderSymbol() != Symbol() ){
            continue;
        }
        if( OrderType() == OP_BUY ){
            POS_n_BUY++;
        }
        else if( OrderType() == OP_SELL ){
            POS_n_SELL++;
        }
    }
    POS_n_total = POS_n_BUY + POS_n_SELL;
}

////////////////////////////////////////////////////////////////////////
bool is_trade_time()
{
    int      ret = false;
    datetime tm  = TimeCurrent();
    int      dow = TimeDayOfWeek( tm );
    int      hh  = TimeHour( tm );
    int      mm  = TimeMinute( tm );

    if( (1 <= dow) && (dow <= 4) ){

        if( hh < trade_open_time_h) ret=false;
        if(  (hh == trade_open_time_h)  &&  (mm>= trade_open_time_m)   ) ret=true;
        if(  (hh == trade_open_time_h+1)  &&  (mm< trade_open_time_m) && (trade_open_time_m!=0)  ) ret=true;

    }
    
    
    if( (dow == 1) && (hh < 12) ){
        ret = false;
    }

    return(ret);
}

////////////////////////////////////////////////////////////////////////
int start()
{
    bool   is_trade_time;
    double pos_tp  = 0.0;
    double pos_sl  = 0.0;
    double pos_lot = 1.0;
    int    ticket;
    int    errcode;

    if( IsTradeAllowed() != true ){
        return(0);
    }


   //\ITP`FbNAlTPɒB|WV
    tp_check();

    is_trade_time = is_trade_time();
    if( is_trade_time == true )
    {
        count_position();
        if( POS_n_total < 1 )
        {
 
           double spl=(Ask-Bid)-split*Point;
           
            if( (get_signal() == true) && spl<=0)
            {
                pos_lot = fixed_lot_size;
                if(TradeSign[SIG_Buy] == true)
                {
                    if( tp1 != 0 ){
                     pos_tp = Ask + (tp1 * Point);
                     }
                    if( sl != 0 ) pos_sl = Ask - (sl * Point);
                    ticket = OrderSend( Symbol(), OP_BUY, pos_lot, Ask, slippage, pos_sl, pos_tp, " ", magic, 0, Yellow );
                    if( ticket < 0 ){
                        errcode = GetLastError();
                        Print( "Error: OrderSend(BUY) = ",ticket, " / Error = ", errcode );
                        Sleep(5000);
                    }
                }
                if(TradeSign[SIG_Sell] == true)
                {
                    if( tp1 != 0 ) {
                    pos_tp = Bid - (tp1 * Point);
                    }
                    if( sl != 0 ) pos_sl = Bid + (sl * Point);
                    ticket = OrderSend( Symbol(), OP_SELL, pos_lot, Bid, slippage, pos_sl, pos_tp, " ", magic, 0, Red );
                    if( ticket < 0 ){
                        errcode = GetLastError();
                        Print( "Error: OrderSend(SELL) = ",ticket, " / Error = ", errcode );
                        Sleep(5000);
                    }
                }
            }
        }
    }

    return(0);
}







void tp_check()
{
   
    for( int i = 0 ; i < OrdersTotal() ; i++ ){
        if( OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) == false ){
            break;
        }
        if( OrderMagicNumber() != magic ){
            continue;
        }
        if( OrderSymbol() != Symbol() ){
            continue;
        }
        if( OrderType() == OP_BUY ){
            if (Bid >=( OrderOpenPrice()+tp2*Point ) ){
               if (OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue))
                OrderPrint();
               else 
               Print("OrderClose() - error:",GetLastError());        
               }
        }
        else if( OrderType() == OP_SELL ){

              if (Ask <=( OrderOpenPrice()-tp2*Point ) ){
                 if (OrderClose(OrderTicket(),OrderLots(),Ask,3,Blue))
                 OrderPrint();
              else 
                 Print("OrderClose() - error:",GetLastError());        
               }
        }
    }



   return(0);   
}










////////////////////////////////////////////////////////////////////////
bool get_signal()
{
    bool enable_trade = false;
    int  trend_up   = 0;
    int  trend_down = 0;
    int  i, j;

    ArrayInitialize( TradeSign, false );
    if( Bars >= 100 ){
        for( i = 0, j = MA_shift ; i < DEF_MA_NUM ; i++, j++ ){
            Buf_MA[0][ i ] = iMA( Symbol(), PERIOD_M30, MA_prm_1, 0, MODE_SMA, PRICE_CLOSE, j );
            Buf_MA[1][ i ] = iMA( Symbol(), PERIOD_M30, MA_prm_2, 0, MODE_SMA, PRICE_CLOSE, j );
            Buf_MA[2][ i ] = iMA( Symbol(), PERIOD_M30, MA_prm_3, 0, MODE_SMA, PRICE_CLOSE, j );
            Buf_MA[3][ i ] = iMA( Symbol(), PERIOD_M30, MA_prm_4, 0, MODE_SMA, PRICE_CLOSE, j );
            Buf_MA[4][ i ] = iMA( Symbol(), PERIOD_M30, MA_prm_5, 0, MODE_SMA, PRICE_CLOSE, j );
        }
        double vRSI = iRSI( Symbol(), PERIOD_M1, RSI_period, PRICE_CLOSE, 0 );
        for( i = 0 ; i < DEF_MA_TYP ; i++ ){
            if((Buf_MA[i][2] < Buf_MA[i][1]) && (Buf_MA[i][1] < Buf_MA[i][0])){
                trend_up++;
            }
            else if((Buf_MA[i][2] > Buf_MA[i][1]) && (Buf_MA[i][1] > Buf_MA[i][0])){
                trend_down++;
            }
        }
        if((trend_up > 3) && (vRSI <= RSI_lower)){
            TradeSign[SIG_Buy] = true;
            enable_trade = true;
        }
        if((trend_down > 3) && (vRSI >= RSI_upper)){
            TradeSign[SIG_Sell] = true;
            enable_trade = true;
        }
    }

    return(enable_trade);
}